import { Document, DocumentQuery, Model, ModelUpdateOptions, QueryFindOneAndUpdateOptions } from 'mongoose';
export declare class BaseModel<T, TDocument extends Document> {
    protected readonly model: Model<TDocument>;
    constructor(model: Model<TDocument>);
    find(conditions?: {}, projection?: {}, options?: {}): DocumentQuery<TDocument[] | null, TDocument>;
    findAll(): DocumentQuery<TDocument[] | null, TDocument>;
    findById(id: string | any): DocumentQuery<TDocument | null, TDocument>;
    findByIdAndRemove(id: any): Promise<TDocument>;
    findByIdAndUpdate(id: any, update: any, options?: QueryFindOneAndUpdateOptions): Promise<TDocument>;
    findOne(conditions: any, projection?: {}, options?: {}): DocumentQuery<TDocument | null, TDocument>;
    insertMany(docs: Partial<T>[]): Promise<TDocument[]>;
    insertOne(doc: Partial<T>): Promise<TDocument>;
    removeOne(conditions: any, projection?: {}, options?: {}): Promise<{
        ok?: number;
        n?: number;
    }>;
    updateMany(conditions: any, update: any, options?: ModelUpdateOptions): Promise<TDocument[]>;
    updateOne(conditions: any, update: any, options?: ModelUpdateOptions): Promise<TDocument>;
    private _updateDocProperties;
}
