"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const operators_1 = require("rxjs/operators");
function getModelToken(model) {
    return `${model}Model`;
}
exports.getModelToken = getModelToken;
function getConnectionToken(name) {
    return `${name}Connection`;
}
exports.getConnectionToken = getConnectionToken;
function handleRetry(retryAttempts = 9, retryDelay = 3000) {
    return (source) => source.pipe(operators_1.retryWhen(e => e.pipe(operators_1.scan((errorCount, error) => {
        common_1.Logger.error(`Unable to connect to the database. Retrying (${errorCount +
            1})...`, '', 'SynapNestMongooseModule');
        if (errorCount + 1 >= retryAttempts) {
            throw error;
        }
        return errorCount + 1;
    }, 0), operators_1.delay(retryDelay))));
}
exports.handleRetry = handleRetry;
