import { Schema } from 'mongoose';
export interface MongooseModuleOptions {
    connectionName?: string;
    retryAttempts?: number;
    retryDelay?: number;
    [key: string]: any;
}
export interface MongooseSchemaDefOptions {
    collection?: string;
    hooks?: SchemaHook[];
    name: string;
    schema: Schema;
}
export interface SchemaHook {
    fn: Function;
    method: HookMethod;
    type: HookType;
}
export declare type HookType = 'post' | 'pre';
export declare type HookMethod = 'save' | 'remove' | 'findOneAndRemove' | 'update';
